#include <hmg.ch>

PROCEDURE c_textbox

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW win_textbox ;
      AT 10, 10 ;
      WIDTH 600 ; 
      HEIGHT 600 ; 
      TITLE "TEXTBOX definition" ;
      MODAL 

      ON KEY ESCAPE ACTION win_textbox.Release

/*
@ <nRow>, <nCol>
      TEXTBOX <ControlName>
      [ OF | PARENT <ParentWindowName> ]
      [ HEIGHT <nHeight> ]
      [ WIDTH <nWidth> ]
      [ FIELD <FieldName> ]
      [ VALUE <cValue> ]
      [ READONLY ]
      [ FONT <cFontName> SIZE <nFontSize> ]
      [ BOLD ] [ ITALIC ] [ UNDERLINE ] [ STRIKEOUT ]
      [ TOOLTIP <ToolTipText> ]
      [ BACKCOLOR <aBackColor> ]
      [ FONTCOLOR <aFontColor> ]
      [ DISABLEDBACKCOLOR <aDisabledBackColor> ]
      [ DISABLEDFONTCOLOR <aDisabledFontColor> ]
      [ MAXLENGTH <nInputLength> ]
      [ UPPERCASE ]
      [ LOWERCASE ]
      [ NUMERIC ]
      [ PASSWORD ]
      [ ON CHANGE <OnChangeProcedure> ]
      [ ON GOTFOCUS <OnGotFocusProcedure> ]
      [ ON LOSTFOCUS <OnLostFocusProcedure> ]
      [ ON ENTER <OnEnterProcedure> ]
      [ RIGHTALIGN ]
      [ INVISIBLE ]
      [ NOTABSTOP ]
      [ HELPID <nHelpId> ]
*/
	  
	  @ 50, 50 LABEL textbox_1 VALUE '@' BOLD
	  @ 50, 70 TEXTBOX textbox_2 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 115 LABEL textbox_3 VALUE ','
	  @ 50, 120 TEXTBOX textbox_4 WIDTH 40 VALUE 100 NUMERIC INPUTMASK '9999'
	  @ 50, 170 LABEL textbox_5 VALUE 'TEXTBOX' WIDTH 70 BOLD
	  @ 50, 250 TEXTBOX textbox_6 WIDTH 150 VALUE 'textbox_1'
	  
	  @ 80, 100 LABEL textbox_7 VALUE 'HEIGHT' WIDTH 70
      @ 80, 180 TEXTBOX textbox_8 WIDTH 40 NUMERIC INPUTMASK '999'
	  @ 80, 230 LABEL textbox_9 VALUE 'WIDTH' WIDTH 70
      @ 80, 310 TEXTBOX textbox_10 WIDTH 40 VALUE 80 NUMERIC INPUTMASK '999'

	  @ 110, 100 LABEL textbox_11 VALUE 'VALUE' WIDTH 70
      @ 110, 180 TEXTBOX textbox_12 WIDTH 200
	  
	  @ 140, 100 LABEL textbox_13 VALUE 'FONT' WIDTH 70
	  @ 140, 180 TEXTBOX textbox_14 WIDTH 100 VALUE 'Arial'
	  @ 140, 290 LABEL textbox_15 VALUE 'SIZE' WIDTH 70
	  @ 140, 370 TEXTBOX textbox_16 WIDTH 40 VALUE 10 NUMERIC INPUTMASK '999'
			
      @ 170, 100 RADIOGROUP textbox_17 ;
			OPTIONS { 'BOLD', 'ITALIC' , 'UNDERLINE' , 'STRIKEOUT', 'NONE' } ;
			VALUE 5 ;
			WIDTH 100 ;
			HORIZONTAL ;
			SPACING 100
			
	  @ 200, 100 LABEL textbox_18 VALUE 'TOOLTIP' WIDTH 70
	  @ 200, 180 TEXTBOX textbox_19 WIDTH 150 VALUE ''
			
      @ 230, 100 RADIOGROUP textbox_20 ;
			OPTIONS { 'CHAR', 'NUMERIC' , 'DATE' } ;
			VALUE 1 ;
			WIDTH 100 ;
			HORIZONTAL ;
			SPACING 100
	  
	  @ 260, 100 LABEL textbox_21 VALUE 'INPUTMASK' WIDTH 70
	  @ 260, 180 TEXTBOX textbox_22 WIDTH 150 VALUE '999,999'
		
	  @ 290, 100 RADIOGROUP textbox_23 ;
			OPTIONS { 'UPPERCASE', 'LOWERCASE' , 'NONE' } ;
			VALUE 3 ;
			WIDTH 100 ;
			HORIZONTAL ;
			SPACING 100
	
	  @ 290, 450 CHECKBOX textbox_23a CAPTION 'PASSWORD' VALUE .F.
	
	  @ 320, 70 LABEL textbox_24 VALUE 'ON CHANGE' WIDTH 100
	  @ 320, 180 TEXTBOX textbox_25 WIDTH 150
	  
	  @ 350, 70 LABEL textbox_26 VALUE 'ON GOTFOCUS' WIDTH 100
	  @ 350, 180 TEXTBOX textbox_27 WIDTH 150

	  @ 380, 70 LABEL textbox_28 VALUE 'ON LOSTFOCUS' WIDTH 100
	  @ 380, 180 TEXTBOX textbox_29 WIDTH 150 

	  @ 410, 70 LABEL textbox_30 VALUE 'ON ENTER' WIDTH 100
	  @ 410, 180 TEXTBOX textbox_31 WIDTH 150
	  
	
	  @ 500, 250 BUTTON textbox_button ;
          CAPTION "OK" ;
          ACTION create_textbox() ;
          WIDTH 100 ;
          HEIGHT 30 
	

   END WINDOW

   CENTER WINDOW win_textbox
   ACTIVATE WINDOW win_textbox

RETURN
*:---------------------------------------------*
PROCEDURE create_textbox

LOCAL _result := '   @ ', _sep := '', _charsep := "'"
 
 _result += alltrim(str(win_textbox.textbox_2.Value)) + ',' + alltrim(str(win_textbox.textbox_2.Value)) + ' TEXTBOX '
 _result += alltrim(win_textbox.textbox_6.Value) + ' '
 
 if win_textbox.textbox_8.Value != 0
    _result += 'HEIGHT ' + alltrim(str(win_textbox.textbox_8.Value)) + ' '
 endif
 
 if win_textbox.textbox_10.Value != 0
    _result += 'WIDTH ' + alltrim(str(win_textbox.textbox_10.Value)) + ' '
 endif
  
if win_textbox.textbox_20.Value = 1
   _sep = "'"
endif
  
 if !empty(win_textbox.textbox_12.Value)
    _result += 'VALUE ' + _sep + alltrim(win_textbox.textbox_12.Value) + _sep + ' '
 endif
 
 if !empty(win_textbox.textbox_14.Value)
    _result += 'FONT ' + _charsep + alltrim(win_textbox.textbox_14.Value) + _charsep + ' '
    
    if !empty(win_textbox.textbox_16.Value)
       _result += 'SIZE ' + alltrim(str(win_textbox.textbox_16.Value)) + ' '
    endif
 endif
 
 do case 
    case win_textbox.textbox_17.Value = 1
	    _result += 'BOLD '
    case win_textbox.textbox_17.Value = 2
	    _result += 'ITALIC '
    case win_textbox.textbox_17.Value = 3
	    _result += 'UNDERLINE '
    case win_textbox.textbox_17.Value = 4
	    _result += 'STRIKEOUT '
 endcase	

*** char
 if win_textbox.textbox_20.Value = 1
 	if win_textbox.textbox_23.Value = 1
	   _result += 'UPPERCASE '
	endif
    if win_textbox.textbox_23.Value = 2
	   _result += 'LOWERCASE '
	endif
	if win_textbox.textbox_23a.Value 
	   _result += 'PASSWORD '
	endif
 endif			

 *** numeric
  if Win_textbox.textbox_20.Value = 2
 	   _result += 'NUMERIC '
	   if !empty(Win_textbox.textbox_22.Value)
          _result += 'INPUTMASK ' + _charsep + alltrim(Win_textbox.textbox_22.Value) + _charsep + ' '
	   endif
 endif
 
 *** date
 if win_textbox.textbox_20.Value = 3
    _result += 'DATE '
 endif
 
*** trigers
if !empty(win_textbox.textbox_25.Value) 
   _result += 'ON CHAGE ' + alltrim(Win_textbox.textbox_25.Value) + ' '
endif
if !empty(win_textbox.textbox_27.Value) 
   _result += 'ON GOTFOCUS ' + alltrim(Win_textbox.textbox_27.Value) + ' '
endif
if !empty(win_textbox.textbox_29.Value) 
   _result += 'ON LOSTFOCUS ' + alltrim(Win_textbox.textbox_29.Value) + ' '
endif
if !empty(win_textbox.textbox_31.Value) 
   _result += 'ON ENTER ' + alltrim(Win_textbox.textbox_31.Value) + ' '
endif

 System.Clipboard := _result
 
 msginfo(_result)
 
 RETURN
